package com.vp.plugin.sample.creatediagramimageshape.actions;

import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;

import com.vp.plugin.ApplicationManager;
import com.vp.plugin.DiagramManager;
import com.vp.plugin.action.VPAction;
import com.vp.plugin.action.VPActionController;
import com.vp.plugin.diagram.IDiagramUIModel;
import com.vp.plugin.diagram.shape.IImageShapeUIModel;
import com.vp.plugin.model.IProject;
import com.vp.plugin.model.factory.IModelElementFactory;
import com.vp.plugin.sample.creatediagramimageshape.CreateDiagramImageShapePlugin;

public class CreateDiagramImageShapeController implements VPActionController {
	
	public void performAction(VPAction aAction) {
	
		DiagramManager diagramManager = ApplicationManager.instance().getDiagramManager(); 
		IDiagramUIModel diagram = diagramManager.createDiagram(DiagramManager.DIAGRAM_TYPE_OVERVIEW_DIAGRAM);
		diagram.setName("Image Shape Test");
		
		File imageFile = new File(CreateDiagramImageShapePlugin.PluginDir, "images/vp_logo.png");
		
		IImageShapeUIModel imageShape = (IImageShapeUIModel) diagramManager.createDiagramElement(diagram, IModelElementFactory.instance().createImageShape());
		imageShape.setMode(IImageShapeUIModel.LINKED);
		imageShape.setImagePath(imageFile.getAbsolutePath());
		try {
			imageShape.setImage(ImageIO.read(imageFile));
			imageShape.setBounds(100, 100, 284, 137);
			diagramManager.openDiagram(diagram);

		} catch (IOException e) {
			ApplicationManager.instance().getViewManager().showMessage(e.getMessage());
			e.printStackTrace();
		}
	}

	public void update(VPAction aAction) {
	}
	

}
